<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Structure Types</TITLE>
<link href="suif1_66.html" rel=Next>
<link href="suif1_64.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_64.html">previous</A>, <A HREF="suif1_66.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC65" HREF="suif1_toc.html#TOC65">Structure and Union Types</A></H2>
<P>
<A NAME="IDX470"></A>
<A NAME="IDX471"></A>
<A NAME="IDX472"></A>
<A NAME="IDX473"></A>

</P>
<P>
<A NAME="IDX474"></A>
<A NAME="IDX475"></A>
<A NAME="IDX476"></A>
Structure and union types are defined with the <CODE>TYPE_STRUCT</CODE> and
<CODE>TYPE_UNION</CODE> operators and use the <CODE>struct_type</CODE> derived type
class.  Both of these types include a name and a list of fields.  The
difference between them is that the fields of a union are all stored at
the same offset so that only one field may be used at a time, while the
fields of a structure are not allowed to overlap.  The <CODE>name</CODE>
method returns the name of a structure or union type, which should be
distinct from the names of other types within the symbol table where it
is defined.  The name is automatically entered in the lexicon
(see section <A HREF="suif1_102.html#SEC102">Lexicon</A>) when it is set with the <CODE>set_name</CODE> method.

</P>
<P>
<A NAME="IDX477"></A>
The <CODE>struct_type</CODE> class contains a field to record the total size
of the type in bits.  The <CODE>set_size</CODE> method is used to assign to
this field.  Because structure and union types may be used as array
elements, they must be able to tile an array without violating any
alignment restrictions.  This means that extra padding may need to be
added at the end of a structure or union.  Consequently, the total size
of the type may be greater than the sizes of the fields.

</P>
<P>
<A NAME="IDX478"></A>
<A NAME="IDX479"></A>
<A NAME="IDX480"></A>
<A NAME="IDX481"></A>
<A NAME="IDX482"></A>
<A NAME="IDX483"></A>
<A NAME="IDX484"></A>
<A NAME="IDX485"></A>
The names, types, and offsets of the fields are stored in
dynamically-allocated arrays within a <CODE>struct_type</CODE> node.  The
<CODE>set_num_fields</CODE> method determines the number of fields and thus
the size of these arrays.  The number of fields may be changed at any
time.  If necessary, additional space will be allocated.  The
<CODE>num_fields</CODE> method returns the current number of fields.  The
<CODE>field_name</CODE>, <CODE>field_type</CODE>, and <CODE>offset</CODE> methods retrieve
the field names, types, and offsets, and the <CODE>set_field_name</CODE>,
<CODE>set_field_type</CODE>, and <CODE>set_offset</CODE> methods change their
values.  The fields are numbered beginning with zero.  For structures
the fields must be in order of increasing offsets.  The field offsets
for union types should all be zero.  The field names are automatically
entered in the lexicon (see section <A HREF="suif1_102.html#SEC102">Lexicon</A>).

</P>
<P>
<A NAME="IDX486"></A>
<A NAME="IDX487"></A>
The <CODE>find_field_by_name</CODE> method can be used to search for a field
with a particular name.  If successful, it returns the index of the
field; otherwise, it returns a value of <CODE>-1</CODE>.  The
<CODE>find_field_by_offset</CODE> method can also be used for structure types
to find the field at a certain offset.  If the specified offset is not
exactly at the beginning of a field, <CODE>find_field_by_offset</CODE> returns
the index of the field containing it and saves the offset within that
field in the <CODE>left</CODE> parameter.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_64.html">previous</A>, <A HREF="suif1_66.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
